<?php
require './common/constant.php';
require './common/kds.util.php';
require 'ConfigDao.php';
$_REQ = keydatas_mergeRequest();
require_once '../common.inc.php';

echo MetaDataManager::doAction($_REQ);

function keydatas_mergeRequest() {
    if (isset($_GET['__kds_flag'])) {
        $_REQ  = array_merge($_GET, $_POST);
    } else {
        $_REQ  = $_POST;
    }
    return $_REQ ;
}

class MetaDataManager{

    public static function doAction($_REQ){
		 $kdsActionFlag = $_REQ['__kds_flag'];
		 if(!isset($kdsActionFlag)||empty($kdsActionFlag)){
		 	return keydatas_failRsp(1403, "action flag error", "无效参数");
		 }
		//获取插件环境信息，不需要密码
		if($kdsActionFlag == 'getPluginInfo'){
			 $data = array('version'=>KDS_PLUGIN_VERSION,'cmsVer'=>DT_VERSION,'phpVer'=>PHP_VERSION);
			 return keydatas_successRsp($data);
		}else{//需要密码
			$configJson=ConfigDao::getConfig();	
			$kds_password =$configJson['keydatas_password'];
			
			if (!isset($_REQ['kds_password'])||empty($_REQ['kds_password']) 
			|| $_REQ['kds_password'] != $kds_password) {
				return keydatas_failRsp(1403, "password error", "提交的发布密码错误");
			}
			
			if($kdsActionFlag == 'findAllModuleArticle'){
				$modules = self::findAllModuleArticle();
				$data = array('version'=>KDS_PLUGIN_VERSION,'datas'=>$modules);
				return keydatas_successRsp($data,'');
			}elseif($kdsActionFlag == 'findModuleAllCategories' && isset($_REQ['moduleid']) && $_REQ['moduleid']){
				$categories = self::findModuleAllCategories($_REQ['moduleid']);
				$data = array('version'=>KDS_PLUGIN_VERSION,'datas'=>$categories);
				return keydatas_successRsp($data,'');
			}else if ($kdsActionFlag == 'findAllAreas'){
				$areas = self::findAllAreas();
				$data = array('version'=>KDS_PLUGIN_VERSION,'datas'=>$areas);
				return keydatas_successRsp($data,'');
			}
			$noServiceData = array('version'=>KDS_PLUGIN_VERSION);
			return keydatas_successRsp($noServiceData,'没有对应服务');
		}
    }
	
	public static function findAllModuleArticle(){
		global $db,$DT_PRE;
		$rows = $db->query("select moduleid,name from {$DT_PRE}module where module = 'article'");
		$allDatas=array();
		while($row = $db->fetch_array($rows)) {
			$result['key'] = $row['moduleid'];
			$result['value'] = $row['name'];
			array_push($allDatas,$result);
		}
		return $allDatas;
	}
	
	
	public static function findModuleAllCategories($moduleid){
		global $db,$DT_PRE;
		$rows = $db->query("select catid,catname from {$DT_PRE}category where moduleid = '$moduleid'");
		$allDatas=array();
		while($row = $db->fetch_array($rows)) {
			$result['key'] = $row['catid'];
			$result['value'] = $row['catname'];
			array_push($allDatas,$result);
		}
		return $allDatas;
	}
	public static function findAllAreas(){
		global $db,$DT_PRE;
		$rows = $db->query("select areaid,areaname from {$DT_PRE}area");
		$allDatas=array();
		while($row = $db->fetch_array($rows)) {
			$result['key'] = $row['areaid'];
			$result['value'] = $row['areaname'];
			array_push($allDatas,$result);
		}
		return $allDatas;
	
	}

}

?>